#cs ----------------------------------------------------------------------------
	
	AutoIt Version: 	3.2.2.0
	Author:        	Chris Richter
	
	Script Function:	Fr Nutzer eines eingeschrnkten Benutzerkontos unter Windows, stellt eine Oberflche zum Start unter Administratorrechten zur Verfgung.
	Resource: Icons by 
	
#ce ----------------------------------------------------------------------------

#Include <Constants.au3>
#include <GUIConstants.au3>
#include <file.au3>
#Include <Misc.au3>
#include <Array.au3>

HotKeySet("^!d", "_DropBoxHotkey") 

Dim $datainicontent
Dim $editcontent[1]
Dim $programmmax
Dim $profil_array
Dim $edit
Dim $aboutitem
Dim $exititem
Dim $item1
Dim $item2
Dim $item3
Dim $optiondropbox
Dim $optionmenu
Dim $optiontraytip
Dim $optionautostart
Dim $optionadmin
Dim $optionpasswd
Dim $optionpathcheck
Dim $traytipflag
Dim $passwdsaveflag = 0
Dim $passwd
Dim $exitflag = 0
Dim $helpitem
Dim $flagoptionsstartup

Opt("TrayMenuMode", 1)
Opt("RunErrorsFatal", 0) ;Setzt das Abstrzen des Programms bei fehlerhaften Daten der Run-Funktion auer Kraft.

programmcheck() ;Erstellt die ausgelesenen Profile und das Traymen aus der data.ini als Meneintrge

TraySetState()
TraySetIcon("C:\WINDOWS\System32\shell32.dll", 160)
TraySetToolTip("AdminRun startet diverse Programme mit Adminrechten.")

While 1
	$msg = TrayGetMsg()
	Select
		Case $msg = 0
			ContinueLoop
		Case $msg = $edit
			editini()
		Case $msg = $aboutitem
			MsgBox(0, "ber AdminRun", "Ein kleines Tool, um Programme mit Administratorrechten zu starten.")
		Case $msg = $exititem
			ExitLoop
		Case $msg = $optiondropbox
			_DropBox()
		Case $msg = $optiontraytip And $traytipflag = 0
			$traytipflag = 1
			TrayItemSetState($optiontraytip, $TRAY_CHECKED)
			IniWrite(@ScriptDir & "\config.ini", "TrayTip", "mode", "1")
		Case $msg = $optiontraytip And $traytipflag = 1
			$traytipflag = 0
			TrayItemSetState($optiontraytip, $TRAY_UNCHECKED)
			IniWrite(@ScriptDir & "\config.ini", "TrayTip", "mode", "0")
		Case $msg = $optionpasswd
			$passwd = ""
			$passwdsaveflag = 0
			TrayItemSetState($optionpasswd, $TRAY_DISABLE)
		Case $msg = $optionpathcheck
			PathCheck()
		Case $msg = $optionadmin
			$adminswap = InputBox("Administrator wechseln", "Bitte den Namen des Administrators eingeben:", IniRead(@ScriptDir & "\config.ini", "Admin", "name", "fehler"))
			If $adminswap <> "" Then
				IniWrite(@ScriptDir & "\config.ini", "Admin", "name", '"' & $adminswap & '"')
				$passwd = ""
				$passwdsaveflag = 0
				TrayItemSetState($optionpasswd, $TRAY_DISABLE)
			Else
			EndIf
		Case $msg = $helpitem
			ShellExecute("manual.html", "", @ScriptDir, "open")
		Case $msg = $optionautostart AND $flagoptionsstartup = 1
			$flagoptionsstartup = 0
			IniWrite("config.ini", "AutoStart", "mode", 0)
			TrayItemSetState($optionautostart,$TRAY_UNCHECKED)
			$ShortcutExists = FileExists(@StartupDir & "\AdminRun.lnk")
			If $ShortcutExists = 1 Then
				FileDelete(@StartupDir & "\AdminRun.lnk")
			Else
				MsgBox(0, "Fehler", "Die Verknpfung existiert nicht. Keine Aktion gettigt.")
			EndIf
		Case $msg = $optionautostart AND $flagoptionsstartup = 0
			$flagoptionsstartup = 1
			IniWrite("config.ini", "AutoStart", "mode", 1)
			$ShortcutExists = FileExists(@StartupDir & "\AdminRun.lnk")
			If $ShortcutExists = 1 Then
				MsgBox(0, "Fehler", "Die Verknpfung existiert bereits. Keine Aktion gettigt.")
			Else
				TrayItemSetState($optionautostart,$TRAY_CHECKED)
				FileCreateShortcut(@ScriptFullPath, @StartupDir & "\AdminRun.lnk")
			EndIf
		Case Else
			For $i = 1 To $programmmax[0] Step 1
				If $msg = $profil_array[$i - 1] Then
					$progcode = IniRead(@ScriptDir & "\data.ini", $programmmax[$i], "path", "fehler")
					If $progcode = "fehler" Then
						MsgBox(0, "Fehler", "Fehler beim Erfassen der Programmdaten")
					Else

						;Prfung, ob der String mit dem Verzeichnispfad auch "" enthlt
						$StringLeft = StringLeft($progcode, 1)
						$StringRight = StringRight($progcode, 1)
						If $StringLeft <> '"' Then
							$progcode = '"' & $progcode
						Else
						EndIf
						If $StringRight <> '"' Then
							$progcode = $progcode & '"'
						Else
						EndIf

						$prognamestore = $programmmax[$i]
						$AdminRun = AdminRun($progcode, $prognamestore)
						If $AdminRun = 0 Then ;Zweiter Versuch, falls erster gescheitert
							AdminRun($progcode, $prognamestore)
						EndIf
						TraySetState(1)
					EndIf
				Else
				EndIf
			Next
	EndSelect
WEnd

Exit

Func AdminRun($progcode, $progname) ;Lsst die Programme mit AdminRechten laufen
	If $passwdsaveflag = 0 Then passwordabfrage($progname) ;Abfrage des Speicherstatus des Passworts
	RunAsSet((IniRead(@ScriptDir & "\config.ini", "Admin", "name", "fehler")), @LogonDomain, $passwd)
	If $passwdsaveflag = 0 Then $passwd = "" ;Lschen der Passworteingabe
	If $exitflag <> 1 Then ;Prfen, ob in Func passwortabfrage() abgebrochen wurde
		Run($progcode) ;Programm ausfhren
		If @error = 1 Then
			MsgBox(0, $progname & " ausfhren - Fehler", $progname & " wurde nicht gestartet, da Administratorname und/oder Administratorpasswort falsch waren.")
			$passwdsaveflag = 0 ;Wichtig, sonst wird ein falsches Passwort gespeichert und die Eingabeaufforderung taucht nicht mehr auf
			Return 0
		Else
			If $traytipflag = 1 Then ;Abfragem ob TrayTip angezeigt werden soll
				TrayTip($progname & " ausfhren", "Das Programm " & $progname & " wird geladen", 0, 17)
			Else
			EndIf
			Return 1
		EndIf
	Else
		$exitflag = 0
		Return 1 ;Wichtig, sonst wird auch beim Abbruch eine zweite Eingabeaufforderung angezeigt
	EndIf
	RunAsSet() ;Lschen der Eintrge in RunAsSet

EndFunc   ;==>AdminRun

Func editini() ;Ist noch im Beta-Stadium und muss noch in der Eingangsroutine des Traymens eingebunden werden.

	TraySetState(2)

	;GUI fr die EditControl wird erzeugt, hierin findet die Bearbeitung der Ini-Datei statt
	$editinigui = GUICreate("AdminRun", 500, 635)

	GUICtrlCreateGraphic(0, 0, 500, 60)
	GUICtrlSetBkColor(-1, 0xffffff)
	GUICtrlCreateIcon("C:\WINDOWS\System32\shell32.dll", 274, 15, 15, 32, 32)
	
	$label1 = GUICtrlCreateLabel("Meneintrge bearbeiten", 45, 15, 300)
	GUICtrlSetBkColor($label1, 0xffffff)
	GUICtrlSetFont($label1, 9, 600)

	$label2 = GUICtrlCreateLabel("Fgen Sie neue Eintrge hinzu oder lschen sie Eintrge", 45, 30, 300)
	GUICtrlSetBkColor($label2, 0xffffff)
	GUICtrlSetFont($label2, 8, 400, 2)

	$statuslabel1 = GUICtrlCreateLabel("", 0, 61, 501, 2, BitOR($SS_SIMPLE, $SS_SUNKEN)) ;TRENNZEILE ZWISCHEN LEISTE UND ARBEITSFELD

	$iniedit = GUICtrlCreateEdit("", 10, 73, 480, 517, $ES_AUTOVSCROLL + $ES_AUTOHSCROLL + $WS_VSCROLL + $WS_HSCROLL + $ES_WANTRETURN)
	$addbutton = GUICtrlCreateButton("Hinzufgen", 170, 600, 100)
	$savebutton = GUICtrlCreateButton("Speichern", 280, 600, 100)
	$exitbutton = GUICtrlCreateButton("Zurck", 390, 600, 100)


	GUISetState()

	;Auslesen der Ini-Datei in Array
	_FileReadToArray(@ScriptDir & "\data.ini", $datainicontent)

	;Arrays mit Daten der Ini-Datei in EditControl einbinden (Zeile fr Zeile)
	For $i = 1 To $datainicontent[0] Step 1
		If $datainicontent[$i] = "" Then ;Array ist leer, fgt Leerzeile hinzu
			GUICtrlSetData($iniedit, @CRLF, 1)
		Else ;Array ist nicht leer, Daten und Leerzeile werden hinzugefgt
			GUICtrlSetData($iniedit, $datainicontent[$i] & @CRLF, 1)
		EndIf
	Next

	While 1
		$msg1 = GUIGetMsg()
		Select
			Case $msg1 = 0
				ContinueLoop
			Case $msg1 = $exitbutton Or $msg1 = $GUI_EVENT_CLOSE
				ExitLoop
			Case $msg1 = $savebutton ;Speichert die Daten in der Ini-Datei
				$editcontent[0] = GUICtrlRead($iniedit)
				_FileCreate(@ScriptDir & "\data.ini")
				_FileWriteToLine(@ScriptDir & "\data.ini", 1, $editcontent[0], 1)
				programmdelete()
				programmcheck()
				MsgBox(0, "Speichern", "Daten gespeichert.", 5)
			Case $msg1 = $addbutton ;Erstellt eine Abfrage der erforderlichen Daten fr einen neuen Eintrag
				$addtitel = InputBox("Titel eingeben", "Geben Sie den Titel des Programms ein:")
				$addpath = InputBox("Pfad eingeben", "Geben Sie den Pfad des Programms ein:")
				If $addtitel = "" Then ;Abfrage, ob Daten fehlerhaft sind
					MsgBox(0, "Fehlerhafte Eingabe", "Die Eingabe des Titels und/oder des Pfads war fehlerhaft. Keine Daten hinzugefgt", 5)
				ElseIf $addpath = "" Then
					MsgBox(0, "Fehlerhafte Eingabe", "Die Eingabe des Titels und/oder des Pfads war fehlerhaft. Keine Daten hinzugefgt", 5)
				Else
					GUICtrlSetData($iniedit, @CRLF & "[" & $addtitel & "]" & @CRLF & "path=" & $addpath, 1)
				EndIf
		EndSelect
	WEnd

	GUIDelete($editinigui) ;Lscht die EditGUI, damit wieder nur mit dem Tray gearbeitet wird
	TraySetState(1)

EndFunc   ;==>editini

Func programmcheck() ;Erstellt die Eintrge des Traymens aus der data.ini
	$programmmax = IniReadSectionNames(@ScriptDir & "\data.ini") ;Einlesen der Sections aus data.ini

	;Erstellen des Traymens
	Dim $profil_array[$programmmax[0]]
	For $ii = 1 To $programmmax[0] Step 1
		$profil_array[$ii - 1] = TrayCreateItem($programmmax[$ii])
	Next
	$item1 = TrayCreateItem("")
	$optiondropbox = TrayCreateItem("DropBox (STRG+ALT+d)")
	$optionmenu = TrayCreateMenu("Einstellungen")
	$optionautostart = TrayCreateItem("Autostart", $optionmenu)
	If IniRead(@ScriptDir & "\config.ini", "AutoStart", "mode", "fehler") = 0 Then
		TrayItemSetState($optionautostart, $TRAY_UNCHECKED)
		$flagoptionsstartup = 0
	ElseIf IniRead(@ScriptDir & "\config.ini", "AutoStart", "mode", "fehler") = 1 Then
		TrayItemSetState($optionautostart, $TRAY_CHECKED)
		$flagoptionsstartup = 1
	EndIf
	$optiontraytip = TrayCreateItem("TrayTip anzeigen", $optionmenu)
	If IniRead(@ScriptDir & "\config.ini", "TrayTip", "mode", "fehler") = 0 Then
		TrayItemSetState($optiontraytip, $TRAY_UNCHECKED)
		$traytipflag = 0
	ElseIf IniRead(@ScriptDir & "\config.ini", "TrayTip", "mode", "fehler") = 1 Then
		TrayItemSetState($optiontraytip, $TRAY_CHECKED)
		$traytipflag = 1
	EndIf
	$item3 = TrayCreateItem("", $optionmenu)
	$optionadmin = TrayCreateItem("Administrator eingeben", $optionmenu)
	$optionpasswd = TrayCreateItem("Gespeichertes Passwort lschen", $optionmenu)
	If $passwdsaveflag = 0 Then TrayItemSetState(-1, $TRAY_DISABLE)
	$edit = TrayCreateItem("Meneintrge bearbeiten", $optionmenu)
	$optionpathcheck = TrayCreateItem("Meneintrge checken", $optionmenu)
	$item2 = TrayCreateItem("")
	$aboutitem = TrayCreateItem("ber")
	$helpitem = TrayCreateItem("Hilfe")
	TrayItemSetState(-1, $TRAY_DISABLE)
	$exititem = TrayCreateItem("Beenden")
EndFunc   ;==>programmcheck

Func programmdelete() ;Lscht alle Eintrge des Traymens
	For $s = 1 To $programmmax[0]
		TrayItemDelete($profil_array[$s - 1])
		TrayItemDelete($item1)
		TrayItemDelete($item2)
		TrayItemDelete($item3)
		TrayItemDelete($edit)
		TrayItemDelete($aboutitem)
		TrayItemDelete($exititem)
		TrayItemDelete($helpitem)
		TrayItemDelete($optiondropbox)
		TrayItemDelete($optionmenu)
		TrayItemDelete($optiontraytip)
		TrayItemDelete($optionautostart)
		TrayItemDelete($optionadmin)
		TrayItemDelete($optionpasswd)
		TrayItemDelete($optionpathcheck)
	Next
EndFunc   ;==>programmdelete

Func passwordabfrage($WinTitleProg)
	TraySetState(2)
 
	;GUI fr die Passworteingabe wird erzeugt
	$passwgui = GUICreate("AdminRun - " & $WinTitleProg & " ausfhren", 400, 265)

	GUICtrlCreateGraphic(0, 0, 500, 60)
	GUICtrlSetBkColor(-1, 0xffffff)
	GUICtrlCreateIcon("C:\WINDOWS\System32\shell32.dll", 48, 15, 15, 32, 32)
	
	$label1 = GUICtrlCreateLabel("Administratorrechte fr " & $WinTitleProg, 45, 22, 445, 37)
	GUICtrlSetBkColor($label1, 0xffffff)
	GUICtrlSetFont($label1, 9, 600)
	
	$statuslabel1 = GUICtrlCreateLabel("", 0, 61, 501, 2, BitOR($SS_SIMPLE, $SS_SUNKEN)) ;TRENNZEILE ZWISCHEN LEISTE UND ARBEITSFELD

	GUICtrlCreateLabel('Bitte geben Sie das Passwort fr den Administrator ein:', 75, 80) ;"' & IniRead(@ScriptDir & "\config.ini", "Admin", "name", "fehler") & '" 
	
	GUICtrlCreateLabel('Administrator:', 60, 112)
	$admininput = GUICtrlCreateInput(IniRead(@ScriptDir & "\config.ini", "Admin", "name", "fehler"), 150, 110, 200)
	
	GUICtrlCreateLabel('Passwort:', 60, 142)
	$passwinput = GUICtrlCreateInput("", 150, 140, 200, -1, $ES_PASSWORD)
	GUICtrlSetState(-1, $GUI_FOCUS)

	$passwcheckbox = GUICtrlCreateCheckbox("Passworteingabe fr diese Sitzung speichern", 85, 175)
	GUICtrlCreateLabel("(Bitte beachten Sie, dass dies eine Erhhung des Sicherheitsrisikios bedeutet.)", 15, 195)

	$okaybutton = GUICtrlCreateButton("Annehmen", 95, 225, 100, -1, $BS_DEFPUSHBUTTON)

	$exitbutton = GUICtrlCreateButton("Abbrechen", 205, 225, 100)

	GUISetState()

	While 1
		$msg1 = GUIGetMsg()
		Select
			Case $msg1 = 0
				ContinueLoop
			Case $msg1 = $GUI_EVENT_CLOSE Or $msg1 = $exitbutton
				$exitflag = 1 ;Setzt, die exitflag, damit nicht eine Fehlermeldung fr fehlenden Adminnamen oder -passwort erscheint, obwohl abgebrochen wurde.
				ExitLoop
			Case $msg1 = $okaybutton Or $msg1 = _IsPressed("0D")
				IniWrite(@ScriptDir & "\config.ini", "Admin", "name", '"' & GUICtrlRead($admininput) & '"')
				$passwd = GUICtrlRead($passwinput)
				ExitLoop
			Case $msg1 = $passwcheckbox And GUICtrlRead($passwcheckbox) = $GUI_CHECKED
				$passwdsaveflag = 1
				TrayItemSetState($optionpasswd, $TRAY_ENABLE)
			Case $msg1 = $passwcheckbox And GUICtrlRead($passwcheckbox) = $GUI_UNCHECKED
				$passwdsaveflag = 0
		EndSelect
	WEnd

	GUIDelete($passwgui) ;Lscht die EditGUI, damit wieder nur mit dem Tray gearbeitet wird
EndFunc   ;==>passwordabfrage

Func PathCheck()

	TraySetState(2)

	;GUI fr die EditControl wird erzeugt, hierin findet die Bearbeitung der Ini-Datei statt
	$pathcheckgui = GUICreate("AdminRun", 500, 270)

	GUICtrlCreateGraphic(0, 0, 500, 60)
	GUICtrlSetBkColor(-1, 0xffffff)
	GUICtrlCreateIcon("C:\WINDOWS\System32\shell32.dll", 281, 15, 15, 32, 32)
	
	$label1 = GUICtrlCreateLabel("Meneintrge prfen", 45, 15, 300)
	GUICtrlSetBkColor($label1, 0xffffff)
	GUICtrlSetFont($label1, 9, 600)

	$label2 = GUICtrlCreateLabel("Es wird geprft, ob die Pfade noch bestehen.", 45, 30, 300)
	GUICtrlSetBkColor($label2, 0xffffff)
	GUICtrlSetFont($label2, 8, 400, 2)

	$statuslabel1 = GUICtrlCreateLabel("", 0, 61, 501, 2, BitOR($SS_SIMPLE, $SS_SUNKEN)) ;TRENNZEILE ZWISCHEN LEISTE UND ARBEITSFELD

	$pathcheckedit = GUICtrlCreateEdit("", 10, 73, 480, 150, $ES_AUTOVSCROLL + $ES_AUTOHSCROLL + $WS_VSCROLL + $WS_HSCROLL + $ES_READONLY)

	$exitbutton = GUICtrlCreateButton("Zurck", 200, 235, 100)


	GUISetState()
	
	;IniSectionNames in ein lokales Array auslesen
	Local $inireadsectionnames = IniReadSectionNames(@ScriptDir & "\data.ini")

	;Dimensionierung des lokalen Arrays, das die Pfade aus der Ini-Datei beinhalten soll
	Dim $inireadpaths[$inireadsectionnames[0]]

	;Auslesen der IniSectionValues in der data.ini
	For $i = 1 To $inireadsectionnames[0] Step 1
		$inireadpaths[$i-1] = IniRead(@ScriptDir & "\data.ini", $inireadsectionnames[$i], "path", "fehler") ;Dieses Array enthlt den jeweiligen Pfad-Value einer Section
	Next
	
	;Die Arrays umkehren, damit alphabetisch aufsteigend gesucht wird
	_ArrayReverse($inireadpaths)
	
	;FileExist-Check
	While UBound($inireadpaths) > 0
		
		Local $pathstore = _ArrayPop($inireadpaths) ;Die nach ArrayPop zurckgegebenen Werte zwischenspeichern

		;Filexist-Check, ob die Pfade noch bestehen
			If FileExists($pathstore) = 1 Then
				GUICtrlSetData($pathcheckedit, $pathstore & " ist OK." & @CRLF, 1)
			Else
				GUICtrlSetData($pathcheckedit, $pathstore & " erscheint FEHLERHAFT." & @CRLF, 1)
			EndIf
	WEnd
	
	While 1
		$msg1 = GUIGetMsg()
		Select
			Case $msg1 = 0
				ContinueLoop
			Case $msg1 = $exitbutton Or $msg1 = $GUI_EVENT_CLOSE
				ExitLoop
		EndSelect
	WEnd

	GUIDelete($pathcheckgui) ;Lscht die EditGUI, damit wieder nur mit dem Tray gearbeitet wird

EndFunc

Func _DropBox()
TraySetState(2)
$GUI_DROPBOX = GUICreate("AdminRunDropBox", 50, 50, -1, -1, BitOR($WS_POPUP,$WS_BORDER), $WS_EX_ACCEPTFILES)
WinSetOnTop("AdminRunDropBox", "", 1)
WinSetTrans("AdminRunDropBox", "", 125)

$GUI_DROPBOX_ico = GUICtrlCreateIcon ("C:\WINDOWS\System32\shell32.dll", 160, 0,0,50,50, Default, $WS_EX_TRANSPARENT)
$GUI_DROPBOX_input = GUICtrlCreateEdit("", -1, -1)
GUICtrlSetState(-1, $GUI_DROPACCEPTED + $GUI_DISABLE)

GUISetState()

$nHoverFlag = 0

While 1
	$msg_drpbx = GUIGetMsg()
	$aMousePos = GUIGetCursorInfo()
		$nMousePosError = @error ;Damit das Prog nicht abstrzt, wenn Fenster nicht aktiv und $aMousePos folglich keine Arrays bildet
	Select
		Case $msg_drpbx = $GUI_EVENT_CLOSE
			ExitLoop
		Case $msg_drpbx = $GUI_EVENT_DROPPED
			WinSetState("AdminRunDropBox", "", @SW_HIDE)
			$sGUICtrlRead = StringStripWS(GUICtrlRead($GUI_DROPBOX_input), 2)
			If StringRight($sGUICtrlRead, 4) = ".exe" Then
				$sStringSplit = StringSplit($sGUICtrlRead, "\")
				AdminRun($sGUICtrlRead, $sStringSplit[UBound($sStringSplit)-1])
				GUICtrlSetData($GUI_DROPBOX_input, "", "")
			Else
				MsgBox(0, "Fehler", "Keine ausfhrbare Datei.")
				GUICtrlSetData($GUI_DROPBOX_input, "", "")
			EndIf
			GUICtrlSetImage($GUI_DROPBOX_ico, "C:\WINDOWS\System32\shell32.dll", 160)
			WinSetState("AdminRunDropBox", "", @SW_SHOW)
		Case $nMousePosError <> 1 And $aMousePos[4] = $GUI_DROPBOX_input And $nHoverFlag = 0
				$nHoverFlag = 1
		Case $nMousePosError <> 1 And $aMousePos[4] <> $GUI_DROPBOX_input And $nHoverFlag = 1
				$nHoverFlag = 0
	EndSelect
WEnd

GUIDelete($GUI_DROPBOX)

TraySetState(1)
EndFunc

Func _DropBoxHotkey()
	If WinActive("AdminRunDropBox") Then
		WinClose("AdminRunDropBox")
		TraySetState(1)
	Else
		_DropBox()
	EndIf
EndFunc